"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.specifiersToProperties = specifiersToProperties;
exports.default = _default;

function _react() {
  const data = _interopRequireDefault(require("react"));

  _react = function _react() {
    return data;
  };

  return data;
}

function _utils() {
  const data = require("@umijs/utils");

  _utils = function _utils() {
    return data;
  };

  return data;
}

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function specifiersToProperties(specifiers) {
  return specifiers.map(s => {
    if (_utils().t.isImportDefaultSpecifier(s)) {
      return _utils().t.objectProperty(_utils().t.identifier('default'), s.local);
    } else {
      return _utils().t.objectProperty(s.imported, s.local);
    }
  });
}

function isValidLib(path, libs) {
  return libs.some(lib => {
    if (typeof lib === 'string') {
      return lib === path;
    } else {
      return lib.test(path);
    }
  });
}

function _default() {
  return {
    visitor: {
      Program: {
        exit(path, {
          opts
        }) {
          const variableDeclarations = [];
          let index = path.node.body.length - 1;

          while (index >= 0) {
            const d = path.node.body[index];

            if (_utils().t.isImportDeclaration(d) && isValidLib(d.source.value, opts.libs)) {
              const properties = specifiersToProperties(d.specifiers);
              variableDeclarations.unshift(_utils().t.variableDeclaration('const', [_utils().t.variableDeclarator(_utils().t.objectPattern(properties), _utils().t.awaitExpression(_utils().t.callExpression(_utils().t.import(), [_utils().t.stringLiteral(`${opts.remoteName}/${d.source.value}`)])))]));
              path.node.body.splice(index, 1);
            }

            index -= 1;
          }

          path.node.body = [...variableDeclarations, ...path.node.body];
        }

      }
    }
  };
}